package{
  import flash.display.Graphics;
  import flash.geom.Point;
  import flash.geom.Rectangle;

//--------------------------------------------------------------------//
// {mC}f[^f
  public class VoronoiModel{

// }̖O
    public static const TYPE_NAME:Vector.<String>=
      Vector.<String>(["VD","Gabriel","RelNe","Nearest","MSTree"]);

// }ɑΉrbg
    public static const TYPE_BIT:Vector.<int>=Vector.<int>([1,3,4,6,7]);

// {mC}Ehl[\
    public static const VORONOI:int=0;

// KuGOt\
    public static const GABRIEL:int=1;

// ΋ߖTOt\
    public static const REL_NE:int=2;

// ŋߖTOt\
    public static const NEAREST:int=3;

// ŏS؂\
    public static const MS_TREE:int=4;

// KuGOt̃rbg
    protected static const GABRIEL_BIT:int=4;

// ΋ߖTOt̃rbg
    protected static const REL_NE_BIT:int=8;

// ŋߖTOt̏rbg
    protected static const NEAREST_BIT1:int=16;

// ŋߖTOt̋trbg
    protected static const NEAREST_BIT2:int=32;

// ŏS؂̃rbg
    protected static const MS_TREE_BIT:int=64;

// _̕`攼a
    protected static const POINT_R:int=2;

// _Xg
    public var points:Vector.<Point>;

// hl[ӃXg
    public var edges:Vector.<Edge>;

    public function VoronoiModel(){
      points=new Vector.<Point>();
      edges=new Vector.<Edge>();
    }

//--------------------------------------------------------------------//
// _ǉ
    public function addPoint(p:Point):void{
      for(var i:int=0;i<points.length;i++){
      	if(Point.distance(points[i],p)<POINT_R){
      	  return;
      	}
      }
      points.push(p);
    }

//--------------------------------------------------------------------//
// _
    public function deletePoints():void{
      points.length=0;
      edges.length=0;
    }

//--------------------------------------------------------------------//
// {mC}Ehl[쐬
// region - `̈
    public function create(region:Rectangle):void{
      edges.length=0;
      for(var i:int=0;i<points.length-1;i++){
      	for(var j:int=i+1;j<points.length;j++){
      	  var line1:Line=bisector(region,points[i],points[j]);
      	  var dxba:Number=line1.x2-line1.x1;
      	  var dyba:Number=line1.y2-line1.y1;
      	  var sw:Boolean=true;
      	  for(var k:int=0;k<points.length;k++){
      	    if((k!=i) && (k!=j) && sw){
      	      var line2:Line=bisector(region,points[i],points[k]);
      	      var dx21:Number=line2.x2-line2.x1;
      	      var dy21:Number=line2.y2-line2.y1;
      	      var sw1:Number=dy21*(line2.x2-line1.x1)
      	      	      	    -dx21*(line2.y2-line1.y1);
      	      var sw2:Number=dy21*dxba-dx21*dyba;
// słȂꍇ
      	      if(Math.abs(sw2)>Number.MIN_VALUE){
      	      	var sw3:Number=dx21*(points[i].y-line2.y1)
      	      	      	      -dy21*(points[i].x-line2.x1);
      	      	var sw4:Number=sw3*(dx21*(line1.y1-line2.y1)
      	      	      	      	   -dy21*(line1.x1-line2.x1));
      	      	var sw5:Number=sw3*(dx21*(line1.y2-line2.y1)
      	      	      	      	   -dy21*(line1.x2-line2.x1));
      	      	sw1/=sw2;
      	      	var xt:Number=line1.x1+sw1*dxba;
      	      	var yt:Number=line1.y1+sw1*dyba;
// I_ύX
      	      	if((sw4>0.0) && (sw5<0.0)){
      	      	  line1.x2=xt;
      	      	  line1.y2=yt;
      	      	}
// n_ύX
      	      	else if((sw4<0.0) && (sw5>0.0)){
      	      	  line1.x1=xt;
      	      	  line1.y1=yt;
      	      	}
// {mCӂ
      	      	else if((sw4<0.0) && (sw5<0.0)){
      	      	  sw=false;
      	      	}
      	      }
      	    }
      	  }
// {mC_̒_̋mF
      	  for(k=0;k<points.length;k++){
      	    if((k!=i) && (k!=j) && sw){
      	      var sw6:int=distanceSq(points[k],line1.x1,line1.y1)
      	      	      	 -distanceSq(points[i],line1.x1,line1.y1);
      	      var sw7:int=distanceSq(points[k],line1.x2,line1.y2)
      	      	      	 -distanceSq(points[i],line1.x2,line1.y2);
      	      if((sw6<0) || (sw7<0)) sw=false;
      	    }
          }
// {mCӁEhl[ӂ
      	  if(sw){
      	    edges.push(new Edge(i,j,new Point(line1.x1,line1.y1),
      	      	      	      	new Point(line1.x2,line1.y2),
      	      	      	      	distanceSqp(points[i],points[j])));
          }
      	}
      }
// hl[ӂZɕבւ
      edges.sort(sortLength);
    }

//--------------------------------------------------------------------//
// KuGOt쐬
    public function createGabrielGraph():void{
      for(var i:int=0;i<edges.length;i++){
      	var x1:int=int(edges[i].v1.x);
      	var y1:int=int(edges[i].v1.y);
      	var dx:int=int(edges[i].v2.x)-x1;
      	var dy:int=int(edges[i].v2.y)-y1;
      	var sp:Point=points[edges[i].start];
      	var ep:Point=points[edges[i].end];
      	var f1:int=(ep.y-sp.y)*(ep.x-x1)-(ep.x-sp.x)*(ep.y-y1);
      	var f2:int=dx*(ep.y-y1)-dy*(ep.x-x1);
      	var f3:int=dx*(ep.y-sp.y)-dy*(ep.x-sp.x);

// {mCӂƃhl[ӂꍇ
      	if(((f1>0) && (f2>0) && (f3>f1) && (f3>f2))
      	|| ((f1<0) && (f2<0) && (f3<f1) && (f3<f2))){
      	  edges[i].addBit(GABRIEL_BIT);
      	}
      }
    }

//--------------------------------------------------------------------//
// ΋ߖTOt쐬
    public function createRelNeGraph():void{
      for(var i:int=0;i<edges.length;i++){
      	var sp:Point=points[edges[i].start];
      	var ep:Point=points[edges[i].end];
      	edges[i].addBit(REL_NE_BIT);
      	var sw:Boolean=true;
      	for(var j:int=0;j<points.length;j++){
      	  if((j!=edges[i].start) && (j!=edges[i].end) && sw){
      	    var dlarge:int=int(Math.max(distanceSqp(sp,points[j]),
      	      	      	      	      	distanceSqp(ep,points[j])));
      	    if(dlarge<edges[i].length){
      	      edges[i].addBit(-REL_NE_BIT);
      	      sw=false;
      	    }
      	  }
      	}
      }
    }

//--------------------------------------------------------------------//
// ŋߖTOt쐬
    public function createNearestGraph():void{
      for(var i:int=0;i<points.length;i++){
      	var sw:Boolean=true;
      	var distMin:int=int.MAX_VALUE;
      	var nearest:int=0;
// ŋߖT_T
      	for(var j:int=0;j<points.length;j++){
      	  if(j!=i){
      	    var dist:int=distanceSqp(points[i],points[j]);
      	    if(dist<distMin){
      	      distMin=dist;
      	      nearest=j;
      	    }
      	  }
      	}
      	for(j=0;j<edges.length;j++){
// 
      	  if((edges[j].start==i) && (edges[j].end==nearest)){
      	    edges[j].addBit(NEAREST_BIT1);
      	  }
// t
      	  else if((edges[j].start==nearest) && (edges[j].end==i)){
      	    edges[j].addBit(NEAREST_BIT2);
      	  }
      	}
      }
    }

//--------------------------------------------------------------------//
// ŏS؂쐬
    public function createMinimumSpanTree():void{
      var msTree:MSTree=new MSTree(points.length);
      var msEdgesCount:int=0;
      for(var i:int=0;i<edges.length;i++){
      	if(msEdgesCount>=points.length-1) return;
// TCNȂꍇ
      	if(msTree.isCycle(edges[i].start,edges[i].end)){
      	  msEdgesCount++;
      	  edges[i].addBit(MS_TREE_BIT);
      	  msTree.setCycle(edges[i]);
      	}
      }
    }

//--------------------------------------------------------------------//
// ̂QԂ
    internal function distanceSq(p:Point,x:Number,y:Number):Number{
      return (x-p.x)*(x-p.x)+(y-p.y)*(y-p.y);
    }

//--------------------------------------------------------------------//
// ̂QԂ
    internal function distanceSqp(p1:Point,p2:Point):int{
      return int((p2.x-p1.x)*(p2.x-p1.x)+(p2.y-p1.y)*(p2.y-p1.y));
    }

//--------------------------------------------------------------------//
// 2Ԃ
// region - `̈
// p1 - ̓_ 1
// p2 - ̓_ 2
    internal function bisector(region:Rectangle,p1:Point,p2:Point):Line{
      var dx:Number=p1.x-p2.x;
      var dy:Number=p1.y-p2.y;
      var xm:Number=0.5*(p1.x+p2.x);
      var ym:Number=0.5*(p1.y+p2.y);
      return linePoint(region.width,region.height,xm,ym,dy,-dx);
    }

//--------------------------------------------------------------------//
// [Ԃ
// width - ʕ
// height - ʍ
// x - ʉ߂_ x W
// y - ʉ߂_ y W
// dx - xNg x 
// dy - xNg y 
  internal function linePoint(width:Number,height:Number,
      	      	      	      x:Number,y:Number,
      	      	      	      dx:Number,dy:Number):Line{
      var outfl:Number=10.0;
      var ymin:Number=-outfl*height;
      var ymax:Number=(outfl+1.0)*height;

// 
      if(dx==0){
      	return new Line(x,ymin,x,ymax);
      }
// ̑̏ꍇ
      else{
      	var coef:Number=dy/dx;
      	var x1:Number=-outfl*width;
      	var y1:Number=coef*(x1-x)+y;
      	var x2:Number=(outfl+1.0)*width;
      	var y2:Number=coef*(x2-x)+y;
      	if(y1<ymin){
      	  x1=(ymin-y)/coef+x;
      	  y1=ymin;
      	}
      	else if(y1>ymax){
      	  x1=(ymax-y)/coef+x;
      	  y1=ymax;
      	}
      	if(y2<ymin){
      	  x2=(ymin-y)/coef+x;
      	  y2=ymin;
      	}
      	else if(y2>ymax){
      	  x2=(ymax-y)/coef+x;
      	  y2=ymax;
      	}
      	return new Line(x1,y1,x2,y2);
      }
    }

//--------------------------------------------------------------------//
// _`悷
// graphics - `OtBbNX
// color - _`F
    public function drawPoints(graphics:Graphics,color:uint):void{
      graphics.lineStyle(0,color);
      for(var i:int=0;i<points.length;i++){
      	graphics.beginFill(color);
      	graphics.drawCircle(points[i].x,points[i].y,POINT_R);
      	graphics.endFill();
      }
    }

//--------------------------------------------------------------------//
// hl[}`悷
// graphics - `OtBbNX
// mark `悷}
    public function drawDiagrams(graphics:Graphics,mark:int):void{
      var bit1:int=Math.pow(2,TYPE_BIT[mark]);
      var bit2:int=bit1/2;
      if(mark==NEAREST) bit2/=2;

      for(var i:int=0;i<edges.length;i++){
// ̐}``悷
      	if(edges[i].isDraw(bit1,bit2)){
      	  var sp:Point=points[edges[i].start];
      	  var ep:Point=points[edges[i].end];
      	  graphics.moveTo(sp.x,sp.y);
      	  graphics.lineTo(ep.x,ep.y);
      	}
      }
    }

//--------------------------------------------------------------------//
// {mC}`悷
// graphics - `OtBbNX
    public function drawVoronoi(graphics:Graphics):void{
      for(var i:int=0;i<edges.length;i++){
      	graphics.moveTo(edges[i].v1.x,edges[i].v1.y);
      	graphics.lineTo(edges[i].v2.x,edges[i].v2.y);
      }
    }

//--------------------------------------------------------------------//
// hl[ӂ𒷂Ń\[g
    internal function sortLength(e1:Edge,e2:Edge):int{
      if(e1.length<e2.length){
      	return -1;
      }
      else if(e1.length>e2.length){
      	return 1;
      }
      else{
      	return 0;
      }
    }
  }
}
