package{
  import flash.display.Graphics;
  import flash.display.Sprite;
  import flash.geom.Point;
  import component.ViewModel;

//--------------------------------------------------------------------//
// {mC}\f
  public class VoronoiViewModel extends ViewModel{

// _ҏW[h\
    public static const EDIT_MODE:int=1;

// }`惂[h\
    public static const DIAGRAM_MODE:int=2;

// {mC}f[^f
    internal var model:VoronoiModel;

// \[h
    public var viewMode:int;

// \}`̎
    public var viewType:int;

// wiF
    internal var bgColor:uint;

// _\F
    internal var pointColor:uint;

// e}\F
    internal var diagColor:uint;

// {mC}\F
    internal var voronoiColor:uint;

//--------------------------------------------------------------------//
// model - {mC}f[^f
// graphics - `OtBbNX
// x,y,width,height - \ʒuAA
// bgColor - wiF
// pointColor - _\F
// diagColor - e}\F
// voronoiColor - {mC}\F
    public function VoronoiViewModel(model:VoronoiModel,
      	      	      	      	     graphics:Graphics,x:int,y:int,
      	      	      	      	     width:int,height:int,
      	      	      	      	     bgColor:uint,pointColor:uint,
      	      	      	      	     diagColor:uint,voronoiColor:uint){
      super(graphics,x,y,width,height);
      this.model=model;
      viewMode=EDIT_MODE;
      viewType=VoronoiModel.VORONOI;

      this.bgColor=bgColor;
      this.pointColor=pointColor;
      this.diagColor=diagColor;
      this.voronoiColor=voronoiColor;
    }

//--------------------------------------------------------------------//
// _ǉ
    public function addPoint(x:int,y:int):void{
      if((viewMode==EDIT_MODE) && region.contains(x,y)){
      	model.addPoint(new Point(x,y));
      	draw();
      }
    }

//--------------------------------------------------------------------//
// _
    public function clear():void{
      viewMode=EDIT_MODE;
      model.deletePoints();
      draw();
    }

//--------------------------------------------------------------------//
// `悷}w肷
  public function setType(viewType:int):void{
    this.viewType=viewType;
    draw();
  }

//--------------------------------------------------------------------//
// }
    public function createGraph():void{
      viewMode=DIAGRAM_MODE;
      model.create(region);
      model.createGabrielGraph();
      model.createRelNeGraph();
      model.createNearestGraph();
      model.createMinimumSpanTree();
      draw();
    }

//--------------------------------------------------------------------//
// `悷
    public function draw():void{
      drawInit(bgColor);
      model.drawPoints(graphics,pointColor);
      if(viewMode==DIAGRAM_MODE){
      	graphics.lineStyle(1,diagColor);
      	model.drawDiagrams(graphics,viewType);
      	if(viewType==VoronoiModel.VORONOI){
      	  graphics.lineStyle(1,voronoiColor);
      	  model.drawVoronoi(graphics);
      	}
      }
    }
  }
}
